diff --git a/dmx/dmx.h b/dmx/dmx.h
new file mode 100644
index 0000000..7edf580
--- /dev/null
+++ b/dmx/dmx.h
@@ -0,0 +1,119 @@
+/*
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+
+   xrdp: A Remote Desktop Protocol server.
+   Copyright (C) Jay Sorg 2005-2008
+   Copyright (C) Novell, Inc. 2008
+
+   libdmx main header file
+
+*/
+
+/* include other h files */
+#include "arch.h"
+#include "parse.h"
+#include "os_calls.h"
+#include "defines.h"
+#include <zlib.h>
+
+struct mod
+{
+  int size; /* size of this struct */
+  int version; /* internal version */
+  /* client functions */
+  int (*mod_start)(struct mod* v, int w, int h, int bpp);
+  int (*mod_connect)(struct mod* v);
+  int (*mod_event)(struct mod* v, int msg, tbus param1, tbus param2,
+                   tbus param3, tbus param4);
+  int (*mod_signal)(struct mod* v);
+  int (*mod_end)(struct mod* v);
+  int (*mod_set_param)(struct mod* v, char* name, char* value);
+  int (*mod_session_change)(struct mod* v, int, int);
+  int (*mod_get_wait_objs)(struct mod* v, tbus* read_objs, int* rcount,
+                           tbus* write_objs, int* wcount, int* timeout);
+  int (*mod_check_wait_objs)(struct mod* v);
+  tbus mod_dumby[100 - 9]; /* align, 100 minus the number of mod
+                              functions above */
+  /* server functions */
+  int (*server_begin_update)(struct mod* v);
+  int (*server_end_update)(struct mod* v);
+  int (*server_fill_rect)(struct mod* v, int x, int y, int cx, int cy);
+  int (*server_screen_blt)(struct mod* v, int x, int y, int cx, int cy,
+                           int srcx, int srcy);
+  int (*server_paint_rect)(struct mod* v, int x, int y, int cx, int cy,
+                           char* data, int width, int height, int srcx, int srcy);
+  int (*server_set_cursor)(struct mod* v, int x, int y, char* data, char* mask);
+  int (*server_palette)(struct mod* v, int* palette);
+  int (*server_msg)(struct mod* v, char* msg, int code);
+  int (*server_is_term)(struct mod* v);
+  int (*server_set_clip)(struct mod* v, int x, int y, int cx, int cy);
+  int (*server_reset_clip)(struct mod* v);
+  int (*server_set_fgcolor)(struct mod* v, int fgcolor);
+  int (*server_set_bgcolor)(struct mod* v, int bgcolor);
+  int (*server_set_opcode)(struct mod* v, int opcode);
+  int (*server_set_mixmode)(struct mod* v, int mixmode);
+  int (*server_set_brush)(struct mod* v, int x_orgin, int y_orgin,
+                          int style, char* pattern);
+  int (*server_set_pen)(struct mod* v, int style,
+                        int width);
+  int (*server_draw_line)(struct mod* v, int x1, int y1, int x2, int y2);
+  int (*server_add_char)(struct mod* v, int font, int charactor,
+                         int offset, int baseline,
+                         int width, int height, char* data);
+  int (*server_draw_text)(struct mod* v, int font,
+                          int flags, int mixmode, int clip_left, int clip_top,
+                          int clip_right, int clip_bottom,
+                          int box_left, int box_top,
+                          int box_right, int box_bottom,
+                          int x, int y, char* data, int data_len);
+  int (*server_reset)(struct mod* v, int width, int height, int bpp);
+  int (*server_query_channel)(struct mod* v, int index,
+                              char* channel_name,
+                              int* channel_flags);
+  int (*server_get_channel_id)(struct mod* v, char* name);
+  int (*server_send_to_channel)(struct mod* v, int channel_id,
+                                char* data, int data_len);
+  int (*server_set_login_mode)(struct mod* v, int login_mode);
+  long server_dumby[100 - 25]; /* align, 100 minus the number of server
+                                  functions above */
+  /* common */
+  tbus handle; /* pointer to self as long */
+  tbus wm;
+  tbus painter;
+  int sck;
+  /* mod data */
+  int width;
+  int height;
+  int bpp;
+  int display;
+  int xpid;
+  int sck_closed;
+  char username[256];
+  char password[256];
+  char ip[256];
+  char port[256];
+  char hostname[256];
+  tbus sck_obj;
+  int x11_chanid;
+  unsigned int x11_output;
+  int x11_client_sck;
+  tbus x11_client_sck_obj;
+  int x11_client_sck_closed;
+  int pipefd;
+  unsigned int inflate_level;
+  unsigned int deflate_level;
+  z_stream incoming_stream;
+  z_stream outgoing_stream;
+};
diff --git a/instfiles/Makefile.am b/instfiles/Makefile.am
index 8f8616c..05eeb88 100644
--- a/instfiles/Makefile.am
+++ b/instfiles/Makefile.am
@@ -10,6 +10,6 @@ startscript_DATA = \
 # must be tab below
 install-data-hook:
 	chmod 755 $(DESTDIR)$(sysconfdir)/xrdp/xrdp.sh
-	if [ -w /etc/init.d ]; then rm -f /etc/init.d/xrdp.sh; fi
-	if [ -w /etc/init.d ]; then $(LN_S) $(DESTDIR)$(sysconfdir)/xrdp/xrdp.sh /etc/init.d/xrdp.sh; fi
-	$(DESTDIR)$(bindir)/xrdp-keygen xrdp $(DESTDIR)$(sysconfdir)/xrdp/rsakeys.ini
+	mkdir -p $(DESTDIR)/etc/init.d
+	$(LN_S) $(sysconfdir)/xrdp/xrdp.sh $(DESTDIR)/etc/init.d/xrdp
+#	$(DESTDIR)$(bindir)/xrdp-keygen xrdp $(DESTDIR)$(sysconfdir)/xrdp/rsakeys.ini
diff --git a/instfiles/xrdp.sh b/instfiles/xrdp.sh
index 3671004..870118e 100755
--- a/instfiles/xrdp.sh
+++ b/instfiles/xrdp.sh
@@ -4,8 +4,19 @@
 # maintaned by Jay Sorg
 # chkconfig: 2345 11 89
 # description: starts xrdp
+#
+### BEGIN INIT INFO
+# Provides:          xrdp
+# Required-Start:    $remote_fs
+# Should-Start:      ypbind $syslog firstboot resmgr winbind acpid
+# Should-Stop:       $null
+# Required-Stop:     $null
+# Default-Start:     5
+# Default-Stop:
+# Description:       Start the xrdp daemon
+### END INIT INFO    
 
-SBINDIR=/usr/local/sbin
+SBINDIR=/usr/sbin
 LOG=/dev/null
 CFGDIR=/etc/xrdp
 
@@ -27,26 +38,25 @@ fi
 
 xrdp_start()
 {
-  echo -n "Starting: xrdp and sesman . . "
-  $SBINDIR/xrdp >> $LOG
+  echo "Starting sesman daemon"
   $SBINDIR/xrdp-sesman >> $LOG
-  echo "."
-  sleep 1
+  echo "Starting xrdp daemon"
+  $SBINDIR/xrdp >> $LOG
   return 0;
 }
 
 xrdp_stop()
 {
-  echo -n "Stopping: xrdp and sesman . . "
-  $SBINDIR/xrdp-sesman --kill >> $LOG
+  echo "Stopping xrdp daemon"
   $SBINDIR/xrdp --kill >> $LOG
-  echo "."
+  echo "Stopping sesman daemon"
+  $SBINDIR/xrdp-sesman --kill >> $LOG
   return 0;
 }
 
 is_xrdp_running()
 {
-  ps u --noheading -C xrdp | grep -q -i xrdp
+  ps u --noheading -C xrdp | grep -q -i $SBINDIR/xrdp
   if test $? -eq 0
   then
     return 1;
@@ -57,7 +67,7 @@ is_xrdp_running()
 
 is_sesman_running()
 {
-  ps u --noheading -C xrdp-sesman | grep -q -i xrdp-sesman
+  ps u --noheading -C xrdp-sesman | grep -q -i $SBINDIR/xrdp-sesman
   if test $? -eq 0
   then
     return 1;
@@ -122,7 +132,6 @@ case "$1" in
     ;;
   force-reload|restart)
     check_up
-    echo "Restarting xrdp ..."
     xrdp_stop
     is_xrdp_running
     while ! test $? -eq 0
diff --git a/rdp/rdp_lic.c b/rdp/rdp_lic.c
index 0de448c..5d355bb 100644
--- a/rdp/rdp_lic.c
+++ b/rdp/rdp_lic.c
@@ -293,7 +293,7 @@ static void APP_CC
 rdp_lic_process_issue(struct rdp_lic* self, struct stream* s)
 {
   void* crypt_key;
-  int length;
+  tui32 length;
   int check;
   int i;
 
@@ -320,7 +320,7 @@ rdp_lic_process_issue(struct rdp_lic* self, struct stream* s)
   {
     in_uint8s(s, length);
     in_uint32_le(s, length);
-    if (!s_check_rem(s, length))
+    if (!s_check(s) || length > (tui32) (s->end - s->p))
     {
       return;
     }
diff --git a/rdp/rdp_orders.c b/rdp/rdp_orders.c
index 4bc4d05..853bbd3 100644
--- a/rdp/rdp_orders.c
+++ b/rdp/rdp_orders.c
@@ -433,6 +433,8 @@ rdp_orders_process_secondary_order(struct rdp_orders* self, struct stream* s)
   in_uint16_le(s, length);
   in_uint16_le(s, flags);
   in_uint8(s, type);
+  if (!s_check_rem (s, length + 7))
+      return 0;
   next_order = s->p + length + 7;
   switch (type)
   {
diff --git a/rdp/rdp_rdp.c b/rdp/rdp_rdp.c
index db8bb30..9e08272 100644
--- a/rdp/rdp_rdp.c
+++ b/rdp/rdp_rdp.c
@@ -411,8 +411,27 @@ rdp_rdp_process_color_pointer_pdu(struct rdp_rdp* self, struct stream* s)
   in_uint16_le(s, cursor->height);
   in_uint16_le(s, mlen); /* mask length */
   in_uint16_le(s, dlen); /* data length */
-  in_uint8a(s, cursor->data, dlen);
-  in_uint8a(s, cursor->mask, mlen);
+
+  g_memset (cursor->data, 0, sizeof (cursor->data));
+  if (dlen <= sizeof (cursor->data))
+  {
+    in_uint8a(s, cursor->data, dlen);
+  }
+  else
+  {
+    in_uint8s(s, dlen);
+  }
+
+  g_memset (cursor->mask, 0, sizeof (cursor->mask));
+  if (mlen <= sizeof (cursor->mask))
+  {
+    in_uint8a(s, cursor->mask, mlen);
+  }
+  else
+  {
+    in_uint8s(s, mlen);
+  }
+
   self->mod->server_set_cursor(self->mod, cursor->x, cursor->y,
                                cursor->data, cursor->mask);
 }
@@ -514,6 +533,8 @@ rdp_rdp_process_bitmap_updates(struct rdp_rdp* self, struct stream* s)
   in_uint16_le(s, num_updates);
   for (i = 0; i < num_updates; i++)
   {
+    if (!s_check_rem (s, 18))
+      return;
     in_uint16_le(s, left);
     in_uint16_le(s, top);
     in_uint16_le(s, right);
@@ -526,6 +547,8 @@ rdp_rdp_process_bitmap_updates(struct rdp_rdp* self, struct stream* s)
     in_uint16_le(s, bufsize);
     cx = (right - left) + 1;
     cy = (bottom - top) + 1;
+    if (width > 8192 || height > 8192 || bpp > 32)
+	return;
     bmpdata0 = (char*)g_malloc(width * height * Bpp, 0);
     if (compress)
     {
@@ -535,10 +558,14 @@ rdp_rdp_process_bitmap_updates(struct rdp_rdp* self, struct stream* s)
       }
       else
       {
+        if (!s_check_rem (s, 8))
+	  return;
         in_uint8s(s, 2); /* pad */
         in_uint16_le(s, size);
         in_uint8s(s, 4); /* line_size, final_size */
       }
+      if (!s_check_rem (s, size))
+	  return;
       in_uint8p(s, data, size);
       rdp_bitmap_decompress(bmpdata0, width, height, data, size, Bpp);
       bmpdata1 = rdp_orders_convert_bitmap(bpp, self->mod->xrdp_bpp,
@@ -549,6 +576,8 @@ rdp_rdp_process_bitmap_updates(struct rdp_rdp* self, struct stream* s)
     }
     else /* not compressed */
     {
+      if (!s_check_rem (s, width * height * Bpp))
+	return;
       for (y = 0; y < height; y++)
       {
         data = bmpdata0 + ((height - y) - 1) * (width * Bpp);
diff --git a/sesman/Makefile.am b/sesman/Makefile.am
index 22736e6..41dce1b 100644
--- a/sesman/Makefile.am
+++ b/sesman/Makefile.am
@@ -1,6 +1,9 @@
 INCLUDES = \
   -I$(top_srcdir)/common \
-  -I$(top_srcdir)/sesman/libscp
+  -I$(top_srcdir)/sesman/libscp \
+  $(DBUS_CFLAGS) \
+  $(XAU_CFLAGS) \
+  $(XCB_CFLAGS)
 
 if SESMAN_NOPAM
 AUTH_C = verify_user.c
@@ -44,7 +47,10 @@ xrdp_sessvc_SOURCES = \
 xrdp_sesman_LDADD = \
   $(top_srcdir)/common/libcommon.la \
   $(top_srcdir)/sesman/libscp/libscp.la \
-  $(AUTH_LIB)
+  $(AUTH_LIB) \
+  $(DBUS_LIBS) \
+  $(XAU_LIBS) \
+  $(XCB_LIBS)
 
 xrdp_sessvc_LDADD = \
   $(top_srcdir)/common/libcommon.la
diff --git a/sesman/config.c b/sesman/config.c
index 4af7b69..b48ca29 100644
--- a/sesman/config.c
+++ b/sesman/config.c
@@ -29,6 +29,7 @@
 #include "list.h"
 #include "file.h"
 #include "sesman.h"
+#include "defines.h"
 
 extern struct config_sesman* g_cfg;
 
@@ -88,9 +89,10 @@ config_read(struct config_sesman* cfg)
   /* read global config */
   config_read_globals(fd, cfg, param_n, param_v);
 
-  /* read Xvnc/X11rdp parameter list */
+  /* read Xvnc/X11rdp/Xdmx parameter list */
   config_read_vnc_params(fd, cfg, param_n, param_v);
   config_read_rdp_params(fd, cfg, param_n, param_v);
+  config_read_dmx_params(fd, cfg, param_n, param_v);
 
   /* read logging config */
   config_read_logging(fd, &(cfg->log), param_n, param_v);
@@ -340,6 +342,10 @@ config_read_sessions(int file, struct config_sessions* se, struct list* param_n,
     if (0 == g_strcasecmp(buf, SESMAN_CFG_SESS_MAX))
     {
       se->max_sessions = g_atoi((char*)list_get_item(param_v, i));
+      if (se->max_sessions > MAX_SESSIONS_LIMIT)
+	  se->max_sessions = MAX_SESSIONS_LIMIT;
+      else if (se->max_sessions < 1)
+	  se->max_sessions = 1;
     }
     if (0 == g_strcasecmp(buf, SESMAN_CFG_SESS_KILL_DISC))
     {
@@ -421,3 +427,30 @@ config_read_vnc_params(int file, struct config_sesman* cs, struct list* param_n,
   return 0;
 }
 
+/******************************************************************************/
+int DEFAULT_CC
+config_read_dmx_params(int file, struct config_sesman* cs, struct list* param_n,
+                       struct list* param_v)
+{
+  int i;
+
+  list_clear(param_v);
+  list_clear(param_n);
+
+  cs->dmx_params=list_create();
+
+  file_read_section(file, SESMAN_CFG_DMX_PARAMS, param_n, param_v);
+  for (i = 0; i < param_n->count; i++)
+  {
+    list_add_item(cs->dmx_params, (long)g_strdup((char*)list_get_item(param_v, i)));
+  }
+
+  /* printing security config */
+  g_printf("Xdmx parameters:\r\n");
+  for (i = 0; i < cs->dmx_params->count; i++)
+  {
+    g_printf("\tParameter %02d                   %s\r\n", i, (char*)list_get_item(cs->dmx_params, i));
+  }
+
+  return 0;
+}
diff --git a/sesman/config.h b/sesman/config.h
index 11b3e58..312c48e 100644
--- a/sesman/config.h
+++ b/sesman/config.h
@@ -53,6 +53,7 @@
 
 #define SESMAN_CFG_RDP_PARAMS        "X11rdp"
 #define SESMAN_CFG_VNC_PARAMS        "Xvnc"
+#define SESMAN_CFG_DMX_PARAMS        "Xdmx"
 
 #define SESMAN_CFG_LOGGING           "Logging"
 #define SESMAN_CFG_LOG_FILE          "LogFile"
@@ -187,6 +188,11 @@ struct config_sesman
    */
   struct list* rdp_params;
   /**
+   * @var dmx_params
+   * @brief Xdmx additional parameter list
+   */
+  struct list* dmx_params;
+  /**
    * @var log
    * @brief Log configuration struct
    */
@@ -298,5 +304,20 @@ int DEFAULT_CC
 config_read_vnc_params(int file, struct config_sesman* cs, struct list* param_n,
                        struct list* param_v);
 
+
+/**
+ *
+ * @brief Reads sesman [Xdmx] configuration section
+ * @param file configuration file descriptor
+ * @param cs pointer to a config_sesman struct
+ * @param param_n parameter name list
+ * @param param_v parameter value list
+ * @return 0 on success, 1 on failure
+ *
+ */
+int DEFAULT_CC
+config_read_dmx_params(int file, struct config_sesman* cs, struct list* param_n,
+                       struct list* param_v);
+
 #endif
 
diff --git a/sesman/env.c b/sesman/env.c
index 066277d..a8ba865 100644
--- a/sesman/env.c
+++ b/sesman/env.c
@@ -60,7 +60,7 @@ env_check_password_file(char* filename, char* password)
 
 /******************************************************************************/
 int DEFAULT_CC
-env_set_user(char* username, char* passwd_file, int display)
+env_set_user(char* username, char* passwd_file, int display, char* auth_file)
 {
   int error;
   int pw_uid;
@@ -97,6 +97,7 @@ env_set_user(char* username, char* passwd_file, int display)
       g_set_current_dir(pw_dir);
       g_sprintf(text, ":%d.0", display);
       g_setenv("DISPLAY", text, 1);
+      g_setenv("XAUTHORITY", auth_file, 1);
       if (passwd_file != 0)
       {
         if (0 == g_cfg->auth_file_path)
diff --git a/sesman/env.h b/sesman/env.h
index 77deb08..63544f8 100644
--- a/sesman/env.h
+++ b/sesman/env.h
@@ -45,11 +45,12 @@ env_check_password_file(char* filename, char* password);
  * @param username Username 
  * @param passwd_file VNC password file
  * @param display The session display
+ * @param auth_File The session authorization file
  * @return 0 on success, g_getuser_info() error codes on error
  *
  */
 int DEFAULT_CC
-env_set_user(char* username, char* passwd_file, int display);
+env_set_user(char* username, char* passwd_file, int display, char* auth_file);
 
 #endif
 
diff --git a/sesman/libscp/libscp_session.c b/sesman/libscp/libscp_session.c
index 6f86e20..fabc093 100644
--- a/sesman/libscp/libscp_session.c
+++ b/sesman/libscp/libscp_session.c
@@ -48,9 +48,11 @@ scp_session_create()
 
   s->username = 0;
   s->password = 0;
+  s->wm = 0;
   s->hostname = 0;
   s->errstr = 0;
   s->locale[0]='\0';
+  s->layout = 0x409;
 
   return s;
 }
@@ -67,6 +69,9 @@ scp_session_set_type(struct SCP_SESSION* s, tui8 type)
     case SCP_SESSION_TYPE_XRDP:
       s->type = SCP_SESSION_TYPE_XRDP;
       break;
+    case SCP_SESSION_TYPE_XDMX:
+      s->type = SCP_SESSION_TYPE_XDMX;
+      break;
     case SCP_SESSION_TYPE_MANAGE:
       s->type = SCP_SESSION_TYPE_MANAGE;
       break;
@@ -204,6 +209,28 @@ scp_session_set_password(struct SCP_SESSION* s, char* str)
 
 /*******************************************************************/
 int
+scp_session_set_wm(struct SCP_SESSION* s, char* str)
+{
+  if (0 == str)
+  {
+    log_message(s_log, LOG_LEVEL_WARNING, "[session:%d] set_wm: null wm", __LINE__);
+    return 1;
+  }
+  if (0 != s->wm)
+  {
+    g_free(s->wm);
+  }
+  s->wm = g_strdup(str);
+  if (0 == s->wm)
+  {
+    log_message(s_log, LOG_LEVEL_WARNING, "[session:%d] set_wm: strdup error", __LINE__);
+    return 1;
+  }
+  return 0;
+}
+
+/*******************************************************************/
+int
 scp_session_set_hostname(struct SCP_SESSION* s, char* str)
 {
   if (0 == str)
@@ -305,6 +332,14 @@ scp_session_set_addr(struct SCP_SESSION* s, int type, void* addr)
 }
 
 /*******************************************************************/
+int
+scp_session_set_layout(struct SCP_SESSION* s, tui16 layout)
+{
+  s->layout = layout;
+  return 0;
+}
+
+/*******************************************************************/
 void
 scp_session_destroy(struct SCP_SESSION* s)
 {
diff --git a/sesman/libscp/libscp_session.h b/sesman/libscp/libscp_session.h
index aefeb20..eacc109 100644
--- a/sesman/libscp/libscp_session.h
+++ b/sesman/libscp/libscp_session.h
@@ -69,6 +69,9 @@ int
 scp_session_set_password(struct SCP_SESSION* s, char* str);
 
 int
+scp_session_set_wm(struct SCP_SESSION* s, char* str);
+
+int
 scp_session_set_hostname(struct SCP_SESSION* s, char* str);
 
 int
@@ -80,6 +83,9 @@ scp_session_set_display(struct SCP_SESSION* s, SCP_DISPLAY display);
 int
 scp_session_set_errstr(struct SCP_SESSION* s, char* str);
 
+int
+scp_session_set_layout(struct SCP_SESSION* s, tui16 layout);
+
 /**
  *
  * @brief destroys a session object
diff --git a/sesman/libscp/libscp_types.h b/sesman/libscp/libscp_types.h
index b8b5d6b..04350aa 100644
--- a/sesman/libscp/libscp_types.h
+++ b/sesman/libscp/libscp_types.h
@@ -41,7 +41,8 @@
 
 #define SCP_SESSION_TYPE_XVNC    0x00
 #define SCP_SESSION_TYPE_XRDP    0x01
-#define SCP_SESSION_TYPE_MANAGE  0x02
+#define SCP_SESSION_TYPE_XDMX    0x02
+#define SCP_SESSION_TYPE_MANAGE  0x03
 
 #define SCP_ADDRESS_TYPE_IPV4 0x00
 #define SCP_ADDRESS_TYPE_IPV6 0x01
@@ -77,11 +78,13 @@ struct SCP_SESSION
   char* username;
   char* password;
   char* hostname;
+  char* wm;
   tui8  addr_type;
   tui32 ipv4addr;
   tui8  ipv6addr[16];
   tui16 display;
   char* errstr;
+  tui16 layout;
 };
 
 struct SCP_DISCONNECTED_SESSION
diff --git a/sesman/libscp/libscp_v0.c b/sesman/libscp/libscp_v0.c
index bd94146..7ccf745 100644
--- a/sesman/libscp/libscp_v0.c
+++ b/sesman/libscp/libscp_v0.c
@@ -56,6 +56,10 @@ enum SCP_CLIENT_STATES_E scp_v0c_connect(struct SCP_CONNECTION* c, struct SCP_SE
   {
     out_uint16_be(c->out_s, 10);
   }
+  else if (s->type == SCP_SESSION_TYPE_XDMX)
+  {
+    out_uint16_be(c->out_s, 20);
+  }
   else
   {
     log_message(s_log, LOG_LEVEL_WARNING, "[v0:%d] connection aborted: network error", __LINE__);
@@ -68,6 +72,9 @@ enum SCP_CLIENT_STATES_E scp_v0c_connect(struct SCP_CONNECTION* c, struct SCP_SE
   sz = g_strlen(s->password);
   out_uint16_be(c->out_s,sz);
   out_uint8a(c->out_s, s->password, sz);
+  sz = g_strlen(s->wm);
+  out_uint16_be(c->out_s,sz);
+  out_uint8a(c->out_s, s->wm, sz);
   out_uint16_be(c->out_s, s->width);
   out_uint16_be(c->out_s, s->height);
   out_uint16_be(c->out_s, s->bpp);
@@ -168,6 +175,11 @@ enum SCP_SERVER_STATES_E scp_v0s_accept(struct SCP_CONNECTION* c, struct SCP_SES
   }
 
   in_uint32_be(c->in_s, size);
+  if (size < 24 || size > 8196)
+  {
+    log_message(s_log, LOG_LEVEL_WARNING, "[v0:%d] connection aborted: size error", __LINE__);
+    return SCP_SERVER_STATE_SIZE_ERR;
+  }
 
   init_stream(c->in_s, 8196);
   if (0!=scp_tcp_force_recv(c->in_sck, c->in_s->data, size-8))
@@ -176,9 +188,11 @@ enum SCP_SERVER_STATES_E scp_v0s_accept(struct SCP_CONNECTION* c, struct SCP_SES
     return SCP_SERVER_STATE_NETWORK_ERR;
   }
 
+  size -= 24;
+
   in_uint16_be(c->in_s, code);
 
-  if (code == 0 || code == 10)
+  if (code == 0 || code == 10 || code == 20)
   {
 	session = scp_session_create();
     if (0 == session)
@@ -192,13 +206,24 @@ enum SCP_SERVER_STATES_E scp_v0s_accept(struct SCP_CONNECTION* c, struct SCP_SES
     {
       scp_session_set_type(session, SCP_SESSION_TYPE_XVNC);
     }
-    else
+    else if (code == 10)
     {
       scp_session_set_type(session, SCP_SESSION_TYPE_XRDP);
     }
+    else
+    {
+      scp_session_set_type(session, SCP_SESSION_TYPE_XDMX);
+    }
 
     /* reading username */
     in_uint16_be(c->in_s, sz);
+    if (sz >= sizeof (buf) || sz > size)
+    {
+      scp_session_destroy(session);
+      log_message(s_log, LOG_LEVEL_WARNING, "[v0:%d] connection aborted: size error", __LINE__);
+      return SCP_SERVER_STATE_SIZE_ERR;
+    }
+    size -= sz;
     buf[sz]='\0';
     in_uint8a(c->in_s, buf, sz);
     if (0 != scp_session_set_username(session, buf))
@@ -210,6 +235,13 @@ enum SCP_SERVER_STATES_E scp_v0s_accept(struct SCP_CONNECTION* c, struct SCP_SES
 
     /* reading password */
     in_uint16_be(c->in_s, sz);
+    if (sz >= sizeof (buf) || sz > size)
+    {
+      scp_session_destroy(session);
+      log_message(s_log, LOG_LEVEL_WARNING, "[v0:%d] connection aborted: size error", __LINE__);
+      return SCP_SERVER_STATE_SIZE_ERR;
+    }
+    size -= sz;
     buf[sz]='\0';
     in_uint8a(c->in_s, buf, sz);
     if (0 != scp_session_set_password(session, buf))
@@ -219,6 +251,24 @@ enum SCP_SERVER_STATES_E scp_v0s_accept(struct SCP_CONNECTION* c, struct SCP_SES
       return SCP_SERVER_STATE_INTERNAL_ERR;
     }
 
+    /* reading wm */
+    in_uint16_be(c->in_s, sz);
+    if (sz >= sizeof (buf) || sz > size)
+    {
+      scp_session_destroy(session);
+      log_message(s_log, LOG_LEVEL_WARNING, "[v0:%d] connection aborted: size error", __LINE__);
+      return SCP_SERVER_STATE_SIZE_ERR;
+    }
+    size -= sz;
+    buf[sz]='\0';
+    in_uint8a(c->in_s, buf, sz);
+    if (0 != scp_session_set_wm(session, buf))
+    {
+      scp_session_destroy(session);
+      log_message(s_log, LOG_LEVEL_WARNING, "[v0:%d] connection aborted: error setting wm", __LINE__);
+      return SCP_SERVER_STATE_INTERNAL_ERR;
+    }
+
     /* width */
     in_uint16_be(c->in_s, sz);
     scp_session_set_width(session, sz);
@@ -228,6 +278,9 @@ enum SCP_SERVER_STATES_E scp_v0s_accept(struct SCP_CONNECTION* c, struct SCP_SES
     /* bpp */
     in_uint16_be(c->in_s, sz);
     scp_session_set_bpp(session, (tui8)sz);
+    /* layout */
+    in_uint16_be(c->in_s, sz);
+    scp_session_set_layout(session, (tui16)sz);
   }
   else
   {
